/*
 * point.cpp
 *
 *  Created on: Sep 3, 2016
 *      Author: zeil
 */

#include <cmath>
#include <point.h>

using namespace std;

double Point::euclideanDist (const Point& p) const
{
	double dx = x - p.x;
	double dy = y - p.y;
	return sqrt ((double)dx*dx + (double)dy*dy);
}


double Point::manhattanDist (const Point& p) const
{
	double dx = x - p.x;
	double dy = y - p.y;
	return abs(dx) + abs(dy);
}


bool operator== (const Point& p1, const Point& p2)
		{
	return (p1.x == p2.x) && (p1.y == p2.y);
		}


ostream& operator<< (ostream& out, const Point& p)
{
	out << "(" << p.x << "," << p.y << ")";
	return out;
}



